'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * Libraries
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     */


/*
* Resources
*/


require('whatwg-fetch');

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/*
* Send request to the server
*/
var ApiRequest = function () {
  function ApiRequest() {
    _classCallCheck(this, ApiRequest);
  }

  _createClass(ApiRequest, null, [{
    key: 'get',
    value: function get(payload, options) {
      return this.request('GET', options.url, payload, options);
    }
  }, {
    key: 'post',
    value: function post(payload, options) {
      return this.request('POST', options.url, payload, options);
    }
  }, {
    key: 'put',
    value: function put(payload, options) {
      return this.request('PUT', options.url, payload, options);
    }
  }, {
    key: 'patch',
    value: function patch(payload, options) {
      return this.request('PATCH', options.url, payload, options);
    }
  }, {
    key: 'delete',
    value: function _delete(payload, options) {
      return this.request('DELETE', options.url, payload, options);
    }

    /* eslint-disable no-param-reassign */

  }, {
    key: 'request',
    value: function request(method, url, payload) {
      var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      var transformedUrl = url;
      payload.sentAt = new Date().toISOString();
      var transformedPayload = _util2.default.deepUnderscore(payload, this._replaceToJSON);

      var attributes = {
        method: method,
        mode: options.mode,
        headers: options.headers,
        credentials: options.credentials,
        body: this._body(transformedPayload, options)
      };

      if (method === 'GET') {
        transformedUrl = transformedUrl + '?' + _util2.default.toUrlParams(transformedPayload);
        delete attributes.body;
      }

      return fetch(transformedUrl.replace(/#$/, ''), attributes);
    }
    /* eslint-enable no-param-reassign */

    // private

    /*
    * Set the body with the resource name if needed
    *
    * @params {hash} payload
    */

  }, {
    key: '_body',
    value: function _body(payload) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!options.bodyWrapper) return JSON.stringify(payload);

      return JSON.stringify(_defineProperty({}, options.bodyWrapper, payload));
    }

    /*
    * Method send to `deepUnderscore` to use `toJSON` if available on object
    *
    * @params {object} value
    */

  }, {
    key: '_replaceToJSON',
    value: function _replaceToJSON(value) {
      if (typeof value.toJSON === 'function') return value.toJSON();

      return value;
    }
  }]);

  return ApiRequest;
}();

exports.default = ApiRequest;