'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _api_request = require('./api_request');

var _api_request2 = _interopRequireDefault(_api_request);

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * Services
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


/*
* Resources
*/


/*
* Object Resource is a wrapper around the API request.
*/
var ObjectResource = function (_APIRequest) {
  _inherits(ObjectResource, _APIRequest);

  function ObjectResource() {
    _classCallCheck(this, ObjectResource);

    return _possibleConstructorReturn(this, (ObjectResource.__proto__ || Object.getPrototypeOf(ObjectResource)).apply(this, arguments));
  }

  _createClass(ObjectResource, null, [{
    key: 'create',
    value: function create() {
      var payload = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      this._validateApiConfiguration();

      return this._callAPI('post', payload, this._buildContextOptions(options));
    }
  }, {
    key: 'update',
    value: function update(id) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      this._validateApiConfiguration();

      return this._callAPI('patch', payload, this._buildContextOptions(Object.assign(options, { id: id })));
    }
  }, {
    key: 'delete',
    value: function _delete(id) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      this._validateApiConfiguration();

      return this._callAPI('delete', payload, this._buildContextOptions(Object.assign(options, { id: id })));
    }

    // Private

  }, {
    key: '_callAPI',
    value: function _callAPI(method) {
      var _get2,
          _this2 = this;

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      return (_get2 = _get(ObjectResource.__proto__ || Object.getPrototypeOf(ObjectResource), method, this)).call.apply(_get2, [this].concat(args)).then(function (response) {
        return _this2._handleResponse(response);
      });
    }
  }, {
    key: '_handleResponse',
    value: function _handleResponse(response) {
      if (response.status >= 200 && response.status < 300) return response.json();

      switch (response.status) {
        case 400:
          throw new Error('Bad response from server');
        case 401:
          throw new Error('Unauthorized, please check your api key');
        case 404:
          throw new Error('Requested Resource not found');
        case 408:
          throw new Error('Server timeout, verify status of the server');
        case 444:
          throw new Error('Server Error, please check with LiveQA');
        case 449:
          throw new Error('Server Error, please check with LiveQA');
        case 501:
          throw new Error('Server Error, please check with LiveQA');
        default:
          return new Error(response.statusText);
      }
    }
  }, {
    key: '_buildContextOptions',
    value: function _buildContextOptions(options) {
      var url = _config2.default.configurations.host + '/api/' + _config2.default.configurations.apiVersion + this.BASE_URL;

      if (options.id) {
        url = url + '/' + options.id;
      }

      return Object.assign({
        url: url,
        mode: 'cors',
        credentials: 'omit',
        headers: this._headers
      }, options);
    }
  }, {
    key: '_validateApiConfiguration',
    value: function _validateApiConfiguration() {
      if (_util2.default.isEmpty(_config2.default.configurations.accountToken)) {
        throw new Error('Your API access are not set. Please check the documentation.');
      }
    }
  }, {
    key: '_headers',
    get: function get() {
      return _util2.default.deepCompact({
        'Access-Control-Allow-Origin': '*',
        'Content-Type': 'application/json',
        Accept: 'application/json',
        'X-Account-Token': _config2.default.configurations.accountToken,
        'X-Space-Name': _config2.default.configurations.spaceName,
        'X-Environment-Name': _config2.default.configurations.environmentName
      });
    }
  }]);

  return ObjectResource;
}(_api_request2.default);

exports.default = ObjectResource;