import {
  expect,
  sourcesPath,
  mockConfigurations,
} from './support/setup.js';

const Message = require(`${sourcesPath}/message`).default;

describe('Message', () => {

  beforeEach(() => {
    mockConfigurations();
  });

  describe('.base', () => {

    it('return the correct data', () => {
      const expected = {
        messageId: (expectedValue) => expect(expectedValue).to.be.a('string'),
        sessionTrackerId: (expectedValue) =>  expect(expectedValue).to.be.a('string'),
        timestamp: (expectedValue) => expect(expectedValue).to.be.a('string'),
      };

      expect(Message.base).to.containSubset(expected);
    })

  });

  describe('.extended', () => {

    it('return the correct data', () => {
      const expected = {
        messageId: (expectedValue) => expect(expectedValue).to.be.a('string'),
        sessionTrackerId: (expectedValue) =>  expect(expectedValue).to.be.a('string'),
        timestamp: (expectedValue) => expect(expectedValue).to.be.a('string'),
        library: {
          language: "javascript",
          name: "liveqa",
          version: "1.5.0",
        }
      };

      expect(Message.extended).to.containSubset(expected);
    })

  });

})
