if (process.versions.node.match(/7./)) {
  require("babel-core/register")({
    plugins: ["transform-async-to-generator"]
  });
}

import Chai, { expect } from 'chai';
import sinon from 'sinon';
import sinonChai from 'sinon-chai';
import path from 'path';
import fetchMock from 'fetch-mock';
import chaiSubset from 'chai-subset';

Chai.use(sinonChai);
Chai.use(chaiSubset);

const specPath = path.resolve(__dirname);
const splitSpecPath = specPath.split('/');

/*
* Exports
*/

export const createSandbox = () => sinon.sandbox.create();

export const libPath = splitSpecPath.slice(0, splitSpecPath.length - 2).join('/');
export const sourcesPath = `${libPath}/sources`;

export const Config = require(`${sourcesPath}/config`).default;
export const mockConfigurations = ()  => {
  Config.initialize({
    accountToken: 'acc_xx',
    spaceName: 'LiveQA',
    environmentName: 'test'
  });
};

exports.expect = expect;
exports.sinon = sinon;
exports.fetchMock = fetchMock;
